# coding: utf-8

"""
    Live Data People API

    This API provides information about people as observed by Live Data

    The version of the OpenAPI document: 1.0
    Contact: support@livedatatechnologies.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
import pprint
from pydantic import BaseModel, ConfigDict, Field, StrictStr, ValidationError, field_validator
from typing import Any, List, Optional
from ldt_people_client_staging.models.report_arr_dep_params import ReportArrDepParams
from ldt_people_client_staging.models.report_demographics_params import ReportDemographicsParams
from ldt_people_client_staging.models.report_stats_params import ReportStatsParams
from ldt_people_client_staging.models.report_tenure_params import ReportTenureParams
from pydantic import StrictStr, Field
from typing import Union, List, Set, Optional, Dict
from typing_extensions import Literal, Self

SEARCHREPORTREQUESTPARAMS_ONE_OF_SCHEMAS = ["ReportArrDepParams", "ReportDemographicsParams", "ReportStatsParams", "ReportTenureParams"]

class SearchReportRequestParams(BaseModel):
    """
    SearchReportRequestParams
    """
    # data type: ReportDemographicsParams
    oneof_schema_1_validator: Optional[ReportDemographicsParams] = None
    # data type: ReportTenureParams
    oneof_schema_2_validator: Optional[ReportTenureParams] = None
    # data type: ReportArrDepParams
    oneof_schema_3_validator: Optional[ReportArrDepParams] = None
    # data type: ReportStatsParams
    oneof_schema_4_validator: Optional[ReportStatsParams] = None
    actual_instance: Optional[Union[ReportArrDepParams, ReportDemographicsParams, ReportStatsParams, ReportTenureParams]] = None
    one_of_schemas: Set[str] = { "ReportArrDepParams", "ReportDemographicsParams", "ReportStatsParams", "ReportTenureParams" }

    model_config = ConfigDict(
        validate_assignment=True,
        protected_namespaces=(),
    )


    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        instance = SearchReportRequestParams.model_construct()
        error_messages = []
        match = 0
        # validate data type: ReportDemographicsParams
        if not isinstance(v, ReportDemographicsParams):
            error_messages.append(f"Error! Input type `{type(v)}` is not `ReportDemographicsParams`")
        else:
            match += 1
        # validate data type: ReportTenureParams
        if not isinstance(v, ReportTenureParams):
            error_messages.append(f"Error! Input type `{type(v)}` is not `ReportTenureParams`")
        else:
            match += 1
        # validate data type: ReportArrDepParams
        if not isinstance(v, ReportArrDepParams):
            error_messages.append(f"Error! Input type `{type(v)}` is not `ReportArrDepParams`")
        else:
            match += 1
        # validate data type: ReportStatsParams
        if not isinstance(v, ReportStatsParams):
            error_messages.append(f"Error! Input type `{type(v)}` is not `ReportStatsParams`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when setting `actual_instance` in SearchReportRequestParams with oneOf schemas: ReportArrDepParams, ReportDemographicsParams, ReportStatsParams, ReportTenureParams. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when setting `actual_instance` in SearchReportRequestParams with oneOf schemas: ReportArrDepParams, ReportDemographicsParams, ReportStatsParams, ReportTenureParams. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Union[str, Dict[str, Any]]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        match = 0

        # deserialize data into ReportDemographicsParams
        try:
            instance.actual_instance = ReportDemographicsParams.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into ReportTenureParams
        try:
            instance.actual_instance = ReportTenureParams.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into ReportArrDepParams
        try:
            instance.actual_instance = ReportArrDepParams.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into ReportStatsParams
        try:
            instance.actual_instance = ReportStatsParams.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into SearchReportRequestParams with oneOf schemas: ReportArrDepParams, ReportDemographicsParams, ReportStatsParams, ReportTenureParams. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into SearchReportRequestParams with oneOf schemas: ReportArrDepParams, ReportDemographicsParams, ReportStatsParams, ReportTenureParams. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> Optional[Union[Dict[str, Any], ReportArrDepParams, ReportDemographicsParams, ReportStatsParams, ReportTenureParams]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())


